SystemOrganization addCategory: #PreferenceBrowser!

Model subclass: #PreferenceBrowser
	instanceVariableNames: 'selectedCategoryIndex selectedPreference searchPattern searchResults'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PreferenceBrowser'!

!PreferenceBrowser methodsFor: 'preferences search' stamp: 'hpt 9/19/2004 12:01'!
defaultSelected
	Preferences chooseInitialSettings! !

!PreferenceBrowser methodsFor: 'preferences search' stamp: 'hpt 9/19/2004 12:04'!
helpSelected 
	Preferences giveHelpWithPreferences! !

!PreferenceBrowser methodsFor: 'accessing' stamp: 'hpt 9/19/2004 00:39'!
selectedPreference: aPreference
	selectedPreference := aPreference.
	self changed: #selectedPreference.
	self changed: #selectedPreferenceIndex.
	self changed: #selectedPreferenceHelpText.! !

!PreferenceBrowser class methodsFor: 'instance creation' stamp: 'hpt 9/18/2004 15:30'!
open
	| browser |
	browser _ self new.
	(PreferenceBrowserMorph withModel: browser)
		openInWorld.
	^browser.	! !

!PreferenceBrowser methodsFor: 'preferences search' stamp: 'hpt 9/19/2004 03:28'!
searchPreferencesFor: pattern
	| result |
	result := pattern asString asLowercase withBlanksTrimmed.
	result ifEmpty: [^self].
	searchResults := self allPreferences select: [:aPreference |
		(aPreference name includesSubstring: result caseSensitive: false) or:
				[aPreference helpString includesSubstring: result caseSensitive: false]].		
	self selectSearchResultsCategory! !

!PreferenceBrowser class methodsFor: 'class initialization' stamp: 'hpt 9/19/2004 12:45'!
unload
	self 
		unregisterFromOpenMenu;
		unregisterFromFlaps.! !

!PreferenceBrowser methodsFor: 'accessing' stamp: 'hpt 9/18/2004 18:00'!
categoryList
	^OrderedCollection new
		add:  self allCategoryLabel;
		addAll: Preferences categoryNames asSortedCollection;
		add: self searchResultsCategoryLabel;
		yourself.
	
	! !

!PreferenceBrowser class methodsFor: 'class initialization' stamp: 'hpt 9/19/2004 12:45'!
initialize
	self
		registerWindowColor;
		registerInOpenMenu;
		registerInFlaps! !

!PreferenceBrowser methodsFor: 'accessing' stamp: 'hpt 9/18/2004 17:59'!
allCategorySelected
	^self selectedCategory = self allCategoryLabel! !

!PreferenceBrowser methodsFor: 'preferences search' stamp: 'hpt 9/19/2004 12:03'!
themeSelected 
	Preferences offerThemesMenu! !

!PreferenceBrowser methodsFor: 'accessing' stamp: 'hpt 9/19/2004 03:28'!
searchResults
	^searchResults ifNil: [searchResults _ #()]! !

!PreferenceBrowser methodsFor: 'accessing' stamp: 'hpt 9/19/2004 03:02'!
searchPattern
	^searchPattern ifNil: [searchPattern := 'Enter search pattern here']! !

!PreferenceBrowser class methodsFor: 'instance creation' stamp: 'hpt 9/19/2004 12:51'!
prototypicalToolWindow
	| window |
	window := PreferenceBrowserMorph withModel: self new.
	window applyModelExtent.
	^window! !

!PreferenceBrowser methodsFor: 'accessing' stamp: 'hpt 9/18/2004 18:01'!
nonSpecialCategorySelected
	^self allCategorySelected not & self searchResultsCategorySelected not! !

!PreferenceBrowser methodsFor: 'accessing' stamp: 'hpt 9/18/2004 21:17'!
selectedPreferenceIndex
	^self selectedCategoryPreferences indexOf: self selectedPreference ifAbsent: [0]! !

!PreferenceBrowser methodsFor: 'accessing' stamp: 'hpt 9/19/2004 03:21'!
searchPattern: aStringOrText
	searchPattern := aStringOrText asString.
	self changed: #searchPattern.
	self searchPreferencesFor: searchPattern.
	^true! !

!PreferenceBrowser methodsFor: 'preferences search' stamp: 'hpt 9/19/2004 12:01'!
saveSelected
	Preferences savePersonalPreferences ! !

!PreferenceBrowser class methodsFor: 'class initialization' stamp: 'hpt 9/19/2004 12:44'!
unregisterFromOpenMenu
	 (TheWorldMenu respondsTo: #registerOpenCommand:)
		ifTrue: [TheWorldMenu unregisterOpenCommand: 'Preference Browser'].
! !

!PreferenceBrowser methodsFor: 'accessing' stamp: 'hpt 9/18/2004 23:41'!
selectedPreferenceIndex: anIndex
	anIndex = 0
		ifTrue: [^self].
	self selectedPreference: (self selectedCategoryPreferences at: anIndex).! !

!PreferenceBrowser class methodsFor: 'window color' stamp: 'hpt 9/18/2004 15:46'!
windowColorSpecification
	"Answer a WindowColorSpec object that declares my preference"

	^ WindowColorSpec classSymbol: self name wording: 'Preference Browser' brightColor: #(0.645 1.0 1.0)	pastelColor: #(0.886 1.0 1.0) helpMessage: 'A tool for expressing personal preferences for numerous options.'! !

!PreferenceBrowser class methodsFor: 'class initialization' stamp: 'hpt 9/19/2004 12:40'!
registerInOpenMenu
	(TheWorldMenu respondsTo: #registerOpenCommand:) ifTrue: [
		TheWorldMenu unregisterOpenCommand: 'Preference Browser'.
		TheWorldMenu registerOpenCommand: {'Preference Browser'. {self. #open}}].
		! !

!PreferenceBrowser methodsFor: 'user interface' stamp: 'hpt 9/19/2004 02:30'!
allCategoryLabel
	^'-- all --' translated! !

!PreferenceBrowser methodsFor: 'accessing' stamp: 'hpt 9/18/2004 18:01'!
searchResultsCategorySelected
	^self selectedCategory = self searchResultsCategoryLabel! !

!PreferenceBrowser methodsFor: 'accessing' stamp: 'hpt 9/18/2004 18:20'!
allPreferences
	^Preferences allPreferenceObjects 
		asSortedCollection: [:pref1 :pref2 | pref1 name < pref2 name].! !

!PreferenceBrowser methodsFor: 'accessing' stamp: 'hpt 9/19/2004 00:01'!
selectedCategory
	^self categoryList at: selectedCategoryIndex ifAbsent: []! !

!PreferenceBrowser methodsFor: 'buttons callbacks' stamp: 'hpt 9/19/2004 03:21'!
searchSelected
	self searchPreferencesFor: self searchPattern.! !

!PreferenceBrowser methodsFor: 'accessing' stamp: 'hpt 9/18/2004 20:53'!
selectedPreference
	^selectedPreference! !

!PreferenceBrowser methodsFor: 'accessing' stamp: 'hpt 9/18/2004 18:21'!
preferencesInCategory: aCategory
	^(Preferences preferenceObjectsInCategory: aCategory) 
		asSortedCollection: [:pref1 :pref2 | pref1 name < pref2 name].! !

!PreferenceBrowser class methodsFor: 'class initialization' stamp: 'hpt 9/19/2004 12:39'!
registerWindowColor
	(Preferences windowColorFor: self name) = Color white
		ifTrue: [ Preferences setWindowColorFor: self name to: (Color colorFrom: self windowColorSpecification brightColor) ].! !

!PreferenceBrowser methodsFor: 'preferences search' stamp: 'hpt 9/19/2004 12:02'!
loadSelected
	Preferences restorePersonalPreferences ! !

!PreferenceBrowser methodsFor: 'accessing' stamp: 'hpt 9/19/2004 03:27'!
selectedCategoryPreferences
	self allCategorySelected
		ifTrue: [^self allPreferences].
	self searchResultsCategorySelected 
		ifTrue: [^self searchResults].
	^self preferencesInCategory: self selectedCategory.
	! !

!PreferenceBrowser class methodsFor: 'class initialization' stamp: 'hpt 9/19/2004 12:48'!
registerInFlaps
	Flaps 
		registerQuad: 
			{ #PreferenceBrowser. 
			#prototypicalToolWindow.
			'Preference Browser' translated.
			'A tool for expressing personal preferences for numerous options' translated }
	 	forFlapNamed: 'Tools' translated.
	Flaps replaceToolsFlap! !

!PreferenceBrowser methodsFor: 'user interface' stamp: 'hpt 9/19/2004 02:30'!
searchResultsCategoryLabel
	^'-- search results --' translated! !

!PreferenceBrowser methodsFor: 'accessing' stamp: 'hpt 9/19/2004 00:34'!
selectedPreferenceHelpText
	self selectedPreference
		ifNil: [^''].
	^self selectedPreference helpString.! !

!PreferenceBrowser methodsFor: 'accessing' stamp: 'hpt 9/18/2004 23:45'!
selectedCategoryIndex: anIndex
	anIndex = 0
		ifTrue: [^self].
	self selectedPreference: nil.
	selectedCategoryIndex := anIndex.
	self changed: #selectedCategoryIndex.! !

!PreferenceBrowser methodsFor: 'user interface' stamp: 'hpt 9/19/2004 02:30'!
windowTitle
	^'Preference Browser' translated! !

!PreferenceBrowser methodsFor: 'accessing' stamp: 'hpt 9/19/2004 03:23'!
selectSearchResultsCategory
	self selectedCategoryIndex: (self categoryList indexOf: self searchResultsCategoryLabel)! !

!PreferenceBrowser class methodsFor: 'class initialization' stamp: 'hpt 9/19/2004 12:47'!
unregisterFromFlaps
	Flaps 
		unregisterQuadsWithReceiver: self;
		replaceToolsFlap! !

!PreferenceBrowser methodsFor: 'accessing' stamp: 'hpt 9/18/2004 20:49'!
selectedCategoryIndex
	^selectedCategoryIndex ifNil: [selectedCategoryIndex := 0].! !

!PreferenceBrowser methodsFor: 'preferences search' stamp: 'hpt 9/19/2004 12:02'!
saveToDiskSelected 
	Preferences storePreferencesToDisk! !

!PreferenceBrowser methodsFor: 'preferences search' stamp: 'hpt 9/19/2004 12:02'!
loadFromDiskSelected 
	Preferences restorePreferencesFromDisk! !

SystemWindow subclass: #PreferenceBrowserMorph
	instanceVariableNames: 'mainPanel defaultButton saveButton loadButton saveToDiskButton loadFromDiskButton themeButton helpButton preferenceList lastKeystrokeTime lastKeystrokes'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PreferenceBrowser'!

!PreferenceBrowserMorph methodsFor: 'submorphs - category list' stamp: 'hpt 9/18/2004 16:08'!
newCategoryListPanel
	^Morph new
		hResizing: #shrinkWrap;
		vResizing: #spaceFill;
		color: Color transparent;
		layoutPolicy: TableLayout new;
		cellInset: 5;
		listCentering: #topLeft;
		listDirection: #topToBottom;
		cellPositioning: #topLeft;
		clipSubmorphs: true;
		addMorphBack: self newCategoryListPanelLabel;
		addMorphBack: self newCategoryList! !

!PreferenceBrowserMorph methodsFor: 'event handling' stamp: 'hpt 9/19/2004 00:16'!
downKeyPressed: anEvent
	self selectedPreferenceIndex:
		(self selectedPreferenceIndex + 1 
				min: self selectedCategoryPreferences size)! !

!PreferenceBrowserMorph methodsFor: 'event handling' stamp: 'hpt 9/19/2004 00:30'!
pageUpKeyPressed: anEvent
	self selectedPreferenceIndex: (self selectedPreferenceIndex - self preferencesShowing size max: 1).
! !

!PreferenceBrowserMorph methodsFor: 'event handling' stamp: 'hpt 9/19/2004 00:19'!
keyPressed: anEvent
	self selectedCategory 
		ifNil: [^self].
	anEvent keyValue = 30
		ifTrue: [^self upKeyPressed: anEvent].
	anEvent keyValue = 31
		ifTrue: [^self downKeyPressed: anEvent].
	anEvent keyValue = 1 
		ifTrue: [^self homeKeyPressed: anEvent].
	anEvent keyValue = 4
		ifTrue: [^self endKeyPressed: anEvent].
	anEvent keyValue = 11
		ifTrue: [^self pageUpKeyPressed: anEvent].
	anEvent keyValue = 12
		ifTrue: [^self pageDownKeyPressed: anEvent].
	self basicKeyPressed: anEvent.! !

!PreferenceBrowserMorph methodsFor: 'submorphs - search panel' stamp: 'hpt 9/19/2004 02:55'!
newSearchButton
	^self basicButton
			label: 'search' translated; 
			actionSelector: #searchSelected;
			setBalloonText: 
				'Type what you want to search for here, then hit ',
				'the "Search" button, or else hit RETURN or ENTER' translated.! !

!PreferenceBrowserMorph methodsFor: 'model access' stamp: 'hpt 9/19/2004 00:10'!
selectedPreferenceIndex
	^self model selectedPreferenceIndex! !

!PreferenceBrowserMorph methodsFor: 'submorphs - search panel' stamp: 'hpt 9/19/2004 03:03'!
newSearchTextField
	^(PluggableTextMorph
		on: self model
		text: #searchPattern
		accept: #searchPattern:)
			hideVScrollBarIndefinitely: true;
			borderInset;
			acceptOnCR: true;
			color: Color white;
			vResizing: #rigid;
			hResizing: #spaceFill;
			height: TextStyle defaultFont height + 4;
			yourself.! !

!PreferenceBrowserMorph methodsFor: 'submorphs - preference list' stamp: 'hpt 9/19/2004 02:19'!
turnOnSelectedPreference
	| m |
	m := (self preferenceListInnerPanel submorphs at: self selectedPreferenceIndex).
	self preferenceList scrollToShow: m bounds.
	m color: (Color gray alpha: 0.2).
	m submorphs first color: Color red.
! !

!PreferenceBrowserMorph methodsFor: 'submorphs - buttons' stamp: 'hpt 9/18/2004 16:51'!
newSeparator
	^BorderedMorph new
		borderWidth: 2;
		borderColor: Color transparent;
		color: self paneColor;
		hResizing: #rigid;
		width: 5;
		vResizing: #spaceFill;
		yourself! !

!PreferenceBrowserMorph methodsFor: 'updating' stamp: 'hpt 9/18/2004 21:20'!
adjustPreferenceListItemsWidth
	| panel |
	self preferenceList scroller submorphs 
		ifEmpty: [^self].
	panel := self preferenceListInnerPanel. 
	panel width: self preferenceList scroller width - 5.
	panel submorphsDo: [:ea | ea hResizing: #rigid; width: panel width].
	self preferenceList setScrollDeltas.! !

!PreferenceBrowserMorph methodsFor: 'model access' stamp: 'hpt 9/19/2004 00:10'!
selectedPreferenceIndex: anIndex
	^self model selectedPreferenceIndex: anIndex! !

!PreferenceBrowserMorph methodsFor: 'updating' stamp: 'hpt 9/18/2004 20:59'!
updateSelectedCategoryPreferences
	self preferenceList scroller removeAllMorphs.
	self preferenceList scroller addMorphBack: self newPreferenceListInnerPanel.
	self adjustPreferenceListItemsWidth.! !

!PreferenceBrowserMorph methodsFor: 'submorphs - buttons' stamp: 'hpt 9/18/2004 16:56'!
loadButton
	^loadButton ifNil: 
		[loadButton := self basicButton 
						label: 'load' translated; 
						actionSelector: #loadSelected;						
						setBalloonText: 
							'Click here to reset all the preferences to their values ',
							'in your Personal Preferences.' translated]! !

!PreferenceBrowserMorph methodsFor: 'model access' stamp: 'hpt 9/19/2004 00:05'!
selectedCategoryIndex: anIndex
	^self model selectedCategoryIndex: anIndex! !

!PreferenceBrowserMorph methodsFor: 'event handling' stamp: 'hpt 9/19/2004 00:16'!
homeKeyPressed: anEvent
	self selectedPreferenceIndex: 1.
! !

!PreferenceBrowserMorph methodsFor: 'submorphs - preference list' stamp: 'hpt 9/19/2004 03:32'!
newPreferenceHelpText 
	| ptm |
	ptm := (PluggableTextMorph
		on: self model
		text: #selectedPreferenceHelpText
		accept: nil).
	ptm
			color: Color transparent;
			borderWidth: 1;
			borderColor: #inset;
			hResizing: #spaceFill;
			vResizing: #rigid;
			height: (TextStyle defaultFont height + 4) * 3.
	^ptm! !

!PreferenceBrowserMorph methodsFor: 'submorphs - preference list' stamp: 'hpt 9/19/2004 00:29'!
preferencesShowing
	| prefs |
	prefs := self preferenceListInnerPanel submorphs
					copyFrom: (self selectedPreferenceIndex max: 1)
					to: self selectedCategoryPreferences size.
	^prefs reject: [:ea | (ea top - prefs first top) > self preferenceList scroller height].! !

!PreferenceBrowserMorph methodsFor: 'event handling' stamp: 'hpt 9/19/2004 00:17'!
endKeyPressed: anEvent
	self selectedPreferenceIndex: self selectedCategoryPreferences size.
! !

!PreferenceBrowserMorph methodsFor: 'event handling' stamp: 'hpt 9/19/2004 03:15'!
mouseDownOn: aPreference event: anEvent
	anEvent yellowButtonPressed
		ifTrue: [aPreference offerPreferenceNameMenu: self with: nil in: nil]! !

!PreferenceBrowserMorph methodsFor: 'geometry' stamp: 'hpt 9/18/2004 21:05'!
extent: aPoint
	super extent: aPoint.
	self fullBounds.
	self adjustPreferenceListItemsWidth.! !

!PreferenceBrowserMorph methodsFor: 'event handling' stamp: 'hpt 9/19/2004 00:16'!
upKeyPressed: anEvent
	self selectedPreferenceIndex: 
			(self selectedPreferenceIndex - 1 max: 1).
! !

!PreferenceBrowserMorph methodsFor: 'submorphs - preference list' stamp: 'hpt 9/19/2004 03:16'!
newPreferenceListPanel
	| panel |
	panel _ Morph new
		hResizing: #spaceFill;
		vResizing: #spaceFill;
		color: Color transparent;
		layoutPolicy: TableLayout new;
		cellInset: 5;
		listCentering: #topLeft;
		listDirection: #topToBottom;
		cellPositioning: #topLeft;
		clipSubmorphs: true;
		addMorphBack: self newPreferenceListPanelLabel;
		addMorphBack: self preferenceList;
		addMorphBack: self newPreferenceHelpText.
	panel
		on: #mouseEnter send: #value: to: [:event | event hand newKeyboardFocus: panel];
		on: #keyStroke send: #keyPressed: to: self.
	^panel.! !

!PreferenceBrowserMorph methodsFor: 'submorphs - category list' stamp: 'hpt 9/18/2004 16:07'!
newCategoryList 
	^(PluggableListMorph
		on: self model
		list: #categoryList
		selected: #selectedCategoryIndex
		changeSelected: #selectedCategoryIndex:)
			color: Color white;
			borderInset;
			vResizing: #spaceFill;
			hResizing: #rigid;
			width: 150;
			yourself.! !

!PreferenceBrowserMorph methodsFor: 'model access' stamp: 'hpt 9/19/2004 00:05'!
selectedCategoryPreferences
	^self model selectedCategoryPreferences! !

!PreferenceBrowserMorph methodsFor: 'submorphs - preference list' stamp: 'hpt 9/19/2004 01:56'!
newPreferenceListInnerPanel
	| panel maxWidth totalHeight |
	panel := Morph new
		color: Color transparent;
		layoutPolicy: TableLayout new;
		listDirection: #topToBottom;
		cellPositioning: #topLeft;
		yourself.
	self selectedCategoryPreferences do: [:aPref |
		panel addMorphBack: (self newPreferenceFormFor: aPref)].
	panel submorphs size = 0
		ifTrue: [^panel].
	maxWidth := (panel submorphs detectMax: [:m | m width]) width.
	panel width: maxWidth.
	totalHeight := ((panel submorphs collect: [:ea | ea height]) inject: 0 into: [:h :tot | h + tot]).
	panel height: totalHeight.
	panel fullBounds.	
	^panel! !

!PreferenceBrowserMorph methodsFor: 'submorphs - buttons' stamp: 'hpt 9/18/2004 16:49'!
newButtonRow
	^BorderedMorph new
		color: Color transparent;
		cellInset: 2;
		layoutInset: 2;
		layoutPolicy: TableLayout new;
		listDirection: #leftToRight;
		listCentering: #topLeft;
		on: #mouseEnter send: #paneTransition: to: self;
		addMorphBack: self defaultButton;
		addMorphBack: self newSeparator;
		addMorphBack: self saveButton;
		addMorphBack: self loadButton;
		addMorphBack: self newSeparator;
		addMorphBack: self saveToDiskButton;
		addMorphBack: self loadFromDiskButton;
		addMorphBack: self newSeparator;
		addMorphBack: self themeButton;
		addMorphBack: self newTransparentFiller;
		addMorphBack: self helpButton;
		yourself.! !

!PreferenceBrowserMorph methodsFor: 'submorphs - preference list' stamp: 'hpt 9/19/2004 02:19'!
turnOffSelectedPreference
	self preferenceListInnerPanel submorphsDo: [:ea |
			ea color: Color transparent.
			ea submorphs first color: Color black].! !

!PreferenceBrowserMorph methodsFor: 'model access' stamp: 'hpt 9/19/2004 00:05'!
selectedCategory
	^self model selectedCategory! !

!PreferenceBrowserMorph methodsFor: 'submorphs - buttons' stamp: 'hpt 9/18/2004 16:56'!
themeButton
	^themeButton ifNil: 
		[themeButton := self basicButton 
						label: 'theme...' translated; 
						actionSelector: #themeSelected;
						setBalloonText: 
							'Numerous "Preferences" govern many things about the ',
							'way Squeak looks and behaves.  Set individual preferences ',
							'using a "Preferences" panel.  Set an entire "theme" of many ',
							'Preferences all at the same time by pressing this "change ',
							'theme" button and choosing a theme to install.  Look in ',
							'category "themes" in Preferences class to see what each ', 
							'theme does; add your own methods to the "themes" ',
							'category and they will show up in the list of theme ',
							'choices.' translated].! !

!PreferenceBrowserMorph methodsFor: 'model access' stamp: 'hpt 9/19/2004 00:05'!
selectedCategoryIndex
	^self model selectedCategoryIndex! !

!PreferenceBrowserMorph methodsFor: 'submorphs - buttons' stamp: 'hpt 9/18/2004 16:56'!
helpButton
	^helpButton ifNil: 
		[helpButton := self basicButton 
						label: 'help' translated; 
						setBalloonText: 
							'Click here to get some hints on use of this Preferences ',
							'Panel' translated;
						actionSelector: #helpSelected]! !

!PreferenceBrowserMorph methodsFor: 'submorphs - buttons' stamp: 'hpt 9/18/2004 16:56'!
loadFromDiskButton
	^loadFromDiskButton ifNil: 
		[loadFromDiskButton := self basicButton 
						label: 'load from disk' translated; 
						actionSelector: #loadFromDiskSelected;						
						setBalloonText: 
							'Click here to load all the preferences from ',
							'their saved values on disk.' translated]! !

!PreferenceBrowserMorph methodsFor: 'model access' stamp: 'hpt 9/19/2004 00:05'!
selectedPreference
	^self model selectedPreference! !

!PreferenceBrowserMorph methodsFor: 'updating' stamp: 'hpt 9/19/2004 00:08'!
updateSelectedPreference
	| index |
	self selectedCategory ifNotNil: [self turnOffSelectedPreference].
	index := self selectedPreferenceIndex.
	index = 0
		ifTrue: [^self].
	self turnOnSelectedPreference.! !

!PreferenceBrowserMorph methodsFor: 'submorphs - preference list' stamp: 'hpt 9/19/2004 02:29'!
newPreferenceListPanelLabel 
	^StringMorph contents: 'Preferences' translated.! !

!PreferenceBrowserMorph methodsFor: 'submorphs - preference list' stamp: 'hpt 9/18/2004 21:19'!
preferenceListInnerPanel
	^self preferenceList scroller submorphs first! !

!PreferenceBrowserMorph class methodsFor: 'instance creation' stamp: 'hpt 9/18/2004 15:31'!
withModel: aPreferenceBrowser
	^self new initializeWithModel: aPreferenceBrowser;
		yourself.! !

!PreferenceBrowserMorph methodsFor: 'event handling' stamp: 'hpt 9/19/2004 00:12'!
basicKeyPressed: anEvent
	| aChar oldSelection nextSelection max milliSeconds nextSelectionList nextSelectionPref |
	aChar := anEvent keyCharacter.
	nextSelection := oldSelection := self selectedPreferenceIndex.
	max := self selectedCategoryPreferences size.
	milliSeconds := Time millisecondClockValue.
	milliSeconds - lastKeystrokeTime > 300 ifTrue: ["just use the one current character for selecting"
		lastKeystrokes := ''].
	lastKeystrokes := lastKeystrokes , aChar asLowercase asString.
	lastKeystrokeTime := milliSeconds.
	nextSelectionList := OrderedCollection newFrom: (self selectedCategoryPreferences copyFrom: oldSelection + 1 to: max).
	nextSelectionList addAll: (self selectedCategoryPreferences copyFrom: 1 to: oldSelection).
	"Get rid of blanks and style used in some lists"
	nextSelectionPref := nextSelectionList detect: [:a | a name withBlanksTrimmed asLowercase beginsWith: lastKeystrokes]
				ifNone: [^ self preferenceList flash"match not found"].
	nextSelection := self selectedCategoryPreferences findFirst: [:a | a  = nextSelectionPref].
	"No change if model is locked"
	oldSelection == nextSelection ifTrue: [^ self preferenceList flash].
	^ self selectedPreferenceIndex: nextSelection! !

!PreferenceBrowserMorph methodsFor: 'submorphs - buttons' stamp: 'hpt 9/18/2004 16:49'!
newTransparentFiller
	^Morph new
		color: Color transparent;
		vResizing: #spaceFill;
		hResizing: #spaceFill;
		yourself.! !

!PreferenceBrowserMorph methodsFor: 'submorphs - buttons' stamp: 'hpt 9/18/2004 16:55'!
defaultButton
	^defaultButton ifNil: 
		[defaultButton := self basicButton 
						label: 'default' translated; 
						actionSelector: #defaultSelected;						
						setBalloonText: 
							'Click here to reset all the preferences to their standard ',
							'default values.' translated]! !

!PreferenceBrowserMorph methodsFor: 'submorphs - buttons' stamp: 'hpt 9/18/2004 16:56'!
saveButton
	^saveButton ifNil: 
		[saveButton := self basicButton 
						label: 'save' translated; 
						actionSelector: #saveSelected;						
						setBalloonText: 
							'Click here to save the current constellation of Preferences ',
							'settings as your personal defaults; you can get them all ',
							'reinstalled with a single gesture by clicking the "Restore ',
							'my Personal Preferences".' translated]! !

!PreferenceBrowserMorph methodsFor: 'submorphs - buttons' stamp: 'hpt 9/18/2004 16:27'!
buttonRowLayoutFrame 
	^LayoutFrame fractions: (0@0 corner: 1@0.075)! !

!PreferenceBrowserMorph methodsFor: 'initialization' stamp: 'hpt 9/19/2004 02:52'!
initializeWithModel: aPreferenceBrowser
	lastKeystrokeTime := 0.
	lastKeystrokes := ''.
	self 
		model: aPreferenceBrowser;
		clipSubmorphs: true;
		setLabel: self model windowTitle;
		name: 'PreferenceBrowser';
		addMorph: self rootPanel fullFrame: self rootPanelLayoutFrame;
		addMorph: self newButtonRow fullFrame: self buttonRowLayoutFrame.! !

!PreferenceBrowserMorph methodsFor: 'submorphs - root panel' stamp: 'hpt 9/19/2004 03:07'!
rootPanel
	^BorderedMorph new
		color: Color transparent;
		layoutInset: 10;
		cellInset: 10;
		layoutPolicy: TableLayout new;
		listDirection: #topToBottom;
		listCentering: #topLeft;
		cellPositioning: #topLeft;
		addMorphBack: self mainPanel;
		addMorphBack: self newSearchPanel;
		yourself.! !

!PreferenceBrowserMorph methodsFor: 'submorphs - preference list' stamp: 'hpt 9/18/2004 23:42'!
preferenceList 
	^preferenceList ifNil:
		[preferenceList := ScrollPane new
			color: Color white;
			borderInset;
			vResizing: #spaceFill;
			hResizing: #spaceFill]! !

!PreferenceBrowserMorph methodsFor: 'submorphs - main panel' stamp: 'hpt 9/19/2004 03:01'!
mainPanel
	^mainPanel ifNil: 
		[mainPanel := Morph new
			color: Color transparent;
			hResizing: #spaceFill;
			vResizing: #spaceFill;
			cellInset: 5;
			layoutPolicy: TableLayout new;
			listCentering: #topLeft;
			listDirection: #leftToRight;
			cellPositioning: #topLeft;
			clipSubmorphs: true;
			on: #mouseEnter send: #paneTransition: to: self;
			addMorphBack: self newCategoryListPanel;
			addMorphBack: self newPreferenceListPanel;
			yourself].! !

!PreferenceBrowserMorph methodsFor: 'submorphs - category list' stamp: 'hpt 9/19/2004 02:29'!
newCategoryListPanelLabel 
	^StringMorph contents: 'Categories' translated.! !

!PreferenceBrowserMorph methodsFor: 'event handling' stamp: 'hpt 9/19/2004 00:24'!
pageDownKeyPressed: anEvent
	self selectedPreferenceIndex: (self selectedPreferenceIndex + self preferencesShowing size min: self selectedCategoryPreferences size).
! !

!PreferenceBrowserMorph methodsFor: 'submorphs - buttons' stamp: 'hpt 9/18/2004 16:58'!
basicButton
	| button |
	button := SimpleButtonMorph new.
	button
		borderWidth: 2;
		borderWidth: 1;
		borderColor: self paneColor;
		on: #mouseEnter send: #value to: [button borderWidth: 2; borderColor: #raised];
		on: #mouseLeave send: #value to: [button borderWidth: 1; borderColor: self paneColor];
		vResizing: #spaceFill;
		useSquareCorners;
		clipSubmorphs: true;
		color: Color transparent;
		target: self model.
	^button! !

!PreferenceBrowserMorph methodsFor: 'submorphs - buttons' stamp: 'hpt 9/18/2004 16:56'!
saveToDiskButton
	^saveToDiskButton ifNil: 
		[saveToDiskButton := self basicButton 
						label: 'save to disk' translated; 
						actionSelector: #saveToDiskSelected;						
						setBalloonText: 
							'Click here to save the current constellation of Preferences ',
							'settings to a file; you can get them all reinstalled with a ', 
							'single gesture by clicking "Restore Settings From Disk".'
								 translated]! !

!PreferenceBrowserMorph methodsFor: 'updating' stamp: 'hpt 9/18/2004 21:16'!
update: aSymbol
	super update: aSymbol.
	aSymbol == #selectedPreference
		ifTrue: [self updateSelectedPreference].
	aSymbol == #selectedCategoryIndex
		ifTrue: [self updateSelectedCategoryPreferences].! !

!PreferenceBrowserMorph methodsFor: 'submorphs - search panel' stamp: 'hpt 9/19/2004 03:06'!
newSearchPanel
	| bottom |
	bottom := Morph new
		color: Color transparent;
		cellInset: 5;
		layoutPolicy: TableLayout new;
		listDirection: #leftToRight;
		listCentering: #topLeft;
		cellPositioning: #topLeft;
		hResizing: #spaceFill;
		vResizing: #shrinkWrap;
		addMorphBack: self newSearchTextField;
		addMorphBack: self newSearchButton;
		yourself.
	^Morph new
		color: Color transparent;
		layoutPolicy: TableLayout new;
		listDirection: #topToBottom;
		listCentering: #topLeft;
		cellPositioning: #topLeft;
		hResizing: #spaceFill;
		vResizing: #shrinkWrap;
		cellInset: 5;
		addMorphBack: (StringMorph contents: 'Search preferences for: ');
		addMorphBack: bottom;
		yourself.! !

!PreferenceBrowserMorph methodsFor: 'submorphs - root panel' stamp: 'hpt 9/19/2004 02:52'!
rootPanelLayoutFrame 
	^LayoutFrame fractions: (0@0.075 corner: 1@1)! !

!PreferenceBrowserMorph methodsFor: 'model access' stamp: 'hpt 9/19/2004 00:06'!
selectedPreference: aPreference
	^self model selectedPreference: aPreference! !

!PreferenceBrowserMorph methodsFor: 'submorphs - preference list' stamp: 'hpt 9/19/2004 02:14'!
newPreferenceFormFor: aPreference
	| form |
	form := aPreference formForPreferenceBrowser
		color: Color transparent;
		fullBounds;
		yourself.
	form
		on: #mouseDown 
		send: #value:
		to: [:anEvent | 
			self selectedPreference: aPreference;
				mouseDownOn: aPreference event: anEvent].
	^form.! !

!Preferences class methodsFor: '*PreferenceBrowser-override' stamp: 'hpt 9/17/2004 23:08'!
categoryNames
	| aSet |
	aSet _ Set new.
	DictionaryOfPreferences do: [:aPreference |
		aSet addAll: (aPreference categoryList collect: [:aCategory | aCategory asSymbol])].
	^aSet.! !

!Preferences class methodsFor: '*PreferenceBrowser-override' stamp: 'hpt 9/17/2004 23:10'!
listOfCategories
	"Answer a list of category names for the preferences panel"
	^ {#?}, self categoryNames asSortedArray, {#'search results'}

	"Preferences listOfCategories"
! !

!Preference methodsFor: '*PreferenceBrowser-override' stamp: 'hpt 9/19/2004 02:29'!
enabledButton
	| outerButton aButton |
	aButton := UpdatingThreePhaseButtonMorph checkBox
		target: self;
		actionSelector: #togglePreferenceValue;
		getSelector: #preferenceValue;
		yourself.	
	outerButton := Morph new
		color: Color transparent;
		layoutPolicy: TableLayout new;
		listDirection: #leftToRight;
		hResizing: #shrinkWrap;
		vResizing: #shrinkWrap;
		cellInset: 2;
		addMorphBack: aButton;
		addMorphBack: (StringMorph 
							contents: 'enabled' translated
							font: (StrikeFont 
									familyName: TextStyle defaultFont familyName
									size: TextStyle defaultFont pointSize - 1));
		yourself.
	^outerButton.! !

!Preference methodsFor: '*PreferenceBrowser-override' stamp: 'hpt 9/19/2004 02:29'!
localToProjectButton
	| outerButton aButton |
	aButton := UpdatingThreePhaseButtonMorph checkBox
		target: self;
		actionSelector: #toggleProjectLocalness;
		getSelector: #localToProject;
		yourself.	
	outerButton := Morph new
		color: Color transparent;
		layoutPolicy: TableLayout new;
		listDirection: #leftToRight;
		hResizing: #shrinkWrap;
		vResizing: #shrinkWrap;
		cellInset: 2;
		addMorphBack: aButton;
		addMorphBack: (StringMorph 
							contents: 'local' translated
							font: (StrikeFont 
									familyName: TextStyle defaultFont familyName
									size: TextStyle defaultFont pointSize - 1));
		yourself.
	^outerButton.! !

!Preference methodsFor: '*PreferenceBrowser-override' stamp: 'hpt 9/19/2004 02:20'!
formForPreferenceBrowser
	^Morph new
		color: Color transparent;
		layoutInset: 2;
		layoutPolicy: TableLayout new;
		listDirection: #leftToRight;
		listCentering: #topLeft;
		cellPositioning: #topLeft;
		hResizing: #shrinkWrap;
		vResizing: #shrinkWrap;
		addMorphBack: (StringMorph contents: self name);
		addMorphBack: (Morph new 
							color: Color transparent; 
							height: 0;  
							hResizing: #spaceFill; 
							yourself); 
		addMorphBack: self enabledButton;
		addMorphBack: (Morph new 
							color: Color transparent; 
							extent: 5@0; 
							yourself);
		addMorphBack: self localToProjectButton;
		yourself.! !
PreferenceBrowser initialize!
